<template>
    <Button :state="state"
    :enabled-text="enabledText"
    :loading-text="loadingText"
    :success-text="successText"
    :on-click="onClick"
    ></Button>
</template>

<script setup lang="ts">
import Button, { type State } from './button.vue';
import { ref, type Ref } from 'vue';
import { delay } from "@/utils/helper";

interface Props {
    endpoint: string,
    method?: string,
    enabledText?: string,
    loadingText?: string,
    successText?: string,
}

const props = withDefaults(defineProps<Props>(), {
    method: 'POST',
    enabledText: 'Enabled',
    loadingText: 'Loading...',
    successText: 'Success!',
});

const state : Ref<State>= ref("ENABLED");

const onClick = async () => {
    if (!props.endpoint) {
        return;
    }
    const response = await fetch(props.endpoint, { method: props.method });
    if (response.ok) {
        state.value = "SUCCESS";
        if (response.redirected) {
            await delay();
            window.location.href = response.url;
        }
    }
};
</script>

